<%@ page language="java" contentType="text/html; charset=ISO-8859-1" pageEncoding="ISO-8859-1" import="fr.cirad.tropgene.*,javax.xml.parsers.*,org.w3c.dom.*,java.io.*,java.util.*,java.net.URLEncoder" %><%

org.apache.log4j.Logger LOG = org.apache.log4j.Logger.getLogger("fr.cirad.embOrSgnDetails");

String sModule = request.getParameter("module");
int numOnglet = Integer.parseInt(request.getParameter("numOnglet"));

String sModulePath = ModuleListManager.getModuleConfigPath(sModule) + java.io.File.separator;
ElementDocumentXml criteresXML = new ElementDocumentXml(sModulePath + "criteres.xml");

HashMap<String, String> fieldNamesToAliases = new HashMap<String, String>();

for (int m = 0; m < criteresXML.racine.getElementsByTagName("onglet").getLength(); m++)
{
	if (numOnglet == m)
	{
		Element onglet = (Element)criteresXML.racine.getElementsByTagName("onglet").item(m);
		NodeList tableNodes = onglet.getElementsByTagName("table");
		// PARCOURIR TOUTES LES TABLES POUR RECUPERER TOUS LES CHAMPS RESULTATS //
		for (int n = 0; n < tableNodes.getLength(); n++){
			Element table = (Element)tableNodes.item(n);
			// LA TABLE //
			Element tab = (Element)table.getElementsByTagName("nom").item(0);
			String sTableName = tab.getTextContent();
			// RECUPERER L'ALIAS DE LA TABLE //
			String alias = tab.getAttribute("alias");
			// LISTE DES CHAMPS RESULTATS DE CETTE TABLE //
			NodeList champsResults = table.getElementsByTagName("champ_result");
			for (int o = 0; o < champsResults.getLength(); o++)
			{
				Element e = (Element)champsResults.item(o);
				fieldNamesToAliases.put(alias+"."+e.getTextContent(), e.getAttribute("nom_significatif"));				
				LOG.debug("fieldNamesToAliases.put : " + alias+"."+e.getTextContent() + " , " + e.getAttribute("nom_significatif"));
			}
		}
		break;
	}
}

// Enumeration<String> paramNames = request.getParameterNames();
// while (paramNames.hasMoreElements())
// {
// 	String s = paramNames.nextElement(); 
// 	out.println(s + " : " + request.getParameter(s) + "<br>");
// }

String seqDbAlias = fieldNamesToAliases.get("sequence.sequence_database");
String accNumberAlias = fieldNamesToAliases.get("sequence.accession_number");

if ("SGN".equals(request.getParameter(seqDbAlias)))
{
	response.sendRedirect("http://solgenomics.net/search/est.pl?request_id=" + request.getParameter(accNumberAlias) + "&request_from=0&request_type=7&search=Search");
	return;
}
else if ("EMBL".equals(request.getParameter(seqDbAlias)))
{
	response.sendRedirect("http://www.ebi.ac.uk/ena/data/view/" + request.getParameter(accNumberAlias));
	return;
}

response.setStatus(HttpServletResponse.SC_NOT_FOUND, "");
%>