<%@ page language="java" contentType="text/html; charset=ISO-8859-1" pageEncoding="ISO-8859-1"%>
<%@ page import="fr.cirad.tropgene.*" %>
<%@ page import="javax.xml.parsers.*" %>
<%@ page import="org.w3c.dom.*" %>	
<%@ page import="java.io.*" %>
<%@ page import="java.sql.*" %>

<%
String nom_driver_sgbd=null;
String nom_driver=null;
String nom_base=null;
String nom_domain=null;
String nom_login=null;
String nom_pass=null;
String tblnames ="";

try
{	
	//recupere le nom de l'onglet selectionne
	String onglet =request.getParameter("onglet");	
	
	//PARSE FICHIER CRITERES.XML
	DocumentBuilderFactory fabrique = DocumentBuilderFactory.newInstance();
    DocumentBuilder constructeur = fabrique.newDocumentBuilder();
    File xml = new File(ModuleListManager.getModuleConfigPath(request.getParameter("module")) + File.separator + "criteres.xml");
    Document document = constructeur.parse(xml);
    
 	// PROPRIETES DU DOM
    document.setXmlVersion("1.0");
    document.setXmlStandalone(true);    
    //CREATION DE L ARBORESCENCE DU DOM
    Element racine = document.getDocumentElement();   
    NodeList balise_onglet =racine.getElementsByTagName("onglet");  
    //pour chaque balise onglet
    for(int i=0; i<balise_onglet.getLength(); i++)
	{    	
	     Element e = (Element)balise_onglet.item(i);
	     if (e.hasAttribute("nom"))
	     {	    	 
	    	String attribute = e.getAttribute("nom");
	    	
	    	int nb=onglet.compareTo(attribute);
	    	 	
			if (onglet.compareTo(attribute) == 0 )
			{							
				//on recupert les noeuds enfants de la balise onglet ayant l'attribut selectionne
				NodeList f = balise_onglet.item(i).getChildNodes();				
				for(int j=0;j<f.getLength();j++)
				{ 
					//on recupert le nom de chaque noeud enfant
					 String g = f.item(j).getNodeName();
					
			 		if(g.compareTo("driver_SGBD")==0)
					 {						
						Element h =(Element)f.item(j);
						if (h.hasAttribute("nom"))
								{
									 nom_driver_sgbd = h.getAttribute("nom");
									out.print(nom_driver_sgbd);
									out.print("\n");							
								}
					 }
			 		if(g.compareTo("driver")==0)
					 {						
						Element h =(Element)f.item(j);
						if (h.hasAttribute("nom"))
								{
									 nom_driver = h.getAttribute("nom");
									out.print(nom_driver);
									out.print("\n");							
								}																
					 }
					 	if(g.compareTo("domaine")==0)
					 {						
						Element h =(Element)f.item(j);
						if (h.hasAttribute("domain"))
								{
									 nom_domain = h.getAttribute("domain");
									
									out.print(nom_domain);
									out.print("\n");							
								}	
					 }
					 
					 	if(g.compareTo("base_de_donnees")==0)
					 {						
						Element h =(Element)f.item(j);
						if (h.hasAttribute("base"))
								{
									 nom_base = h.getAttribute("base");
									out.print(nom_base);
									out.print("\n");							
								}	
					 }
					 
					 if(g.compareTo("login")==0)
					 {						
						Element h =(Element)f.item(j);
						if (h.hasAttribute("log"))
								{
									 nom_login = h.getAttribute("log");
									out.print(nom_login);
									out.print("\n");						
								}	
					 }
					 
					 if(g.compareTo("password")==0)
					 {						
						Element h =(Element)f.item(j);
						if (h.hasAttribute("pass"))
								{
									nom_pass = h.getAttribute("pass");
									out.print(nom_pass);
									out.print("\n");							
								}	
					 }			 		
				}
			}
	     }
	}
    String url=nom_driver+"//"+nom_domain+"/"+nom_base;
	Class.forName(nom_driver_sgbd).newInstance();
    Connection connect =DriverManager.getConnection(url, nom_login, nom_pass);				
	DatabaseMetaData meta = connect.getMetaData();
	ResultSet res = meta.getCatalogs();							   
	while (res.next())
	{								        	 
			String database_name=res.getString("TABLE_CAT");
			out.print(database_name);
			out.print(";");
	}
}
catch(Exception e)
{
	System.out.print(e.getMessage());	
}

%>