<%@ page language="java" import="org.w3c.dom.*,java.util.ArrayList,java.util.HashMap,java.util.Vector,fr.cirad.tropgene.*" contentType="text/html; charset=ISO-8859-1" pageEncoding="ISO-8859-1"%>

<%
String sModule = request.getParameter("module");
String sModulePath = ModuleListManager.getModuleConfigPath(sModule) + java.io.File.separator;

int DISPLAY_LENGTH_THRESHOLD = -1;
String sWebAppHome = "../";
try
{
	DISPLAY_LENGTH_THRESHOLD = Integer.parseInt(TextConstants.get("DISPLAY_LENGTH_THRESHOLD"));
}
catch (Exception ignored)
{}
%>

<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN" "http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
	<meta http-equiv="Content-Type" content="text/html; charset=ISO-8859-1">
	<link rel="stylesheet" type="text/css" href='<%=sWebAppHome+"CSS/onglets.css"%>'/>
	<link rel="stylesheet" type="text/css" href='<%=sWebAppHome+"CSS/interface.css"%>'/>
	<title><%= TextConstants.get("siteTitle") %></title>
	<script type="text/javascript" src='<%=sWebAppHome+"JS/tabber.js"%>'></script>
	<script type="text/javascript" src='<%=sWebAppHome+"JS/jquery-1.3.2.min.js"%>'></script>
	<script type="text/javascript">	
		var searchURL = "<%= sWebAppHome + "SearchServlet" %>";
		var module = "<%= sModule %>";
		var activeTabIndex = 0;
		var selectFilterDependencies = new Array();
		var sortingColumns = new Array();
		var sortingDesc = new Array();
		lengthThreshold = <%= DISPLAY_LENGTH_THRESHOLD %>;
//		var fieldsLinkedToExternalWebSites = new Array();
		var externalWebSiteURLs = new Array();

<%
			String[] lwsURLs = TextConstants.get("linkedWebSites_URLs").split(";");
			String[] lwsNames = TextConstants.get("linkedWebSites_names").split(";");
			for (int i=0; i<lwsNames.length; i++)
			{
				if (lwsNames[i].trim().length() > 0)
				{
%>

		externalWebSiteURLs["<%= lwsNames[i] %>"] = "<%= lwsURLs[i] %>";

<%
					/*String[] linkedFields = TextConstants.get("linkedWebSites_linkedFields_" + lwsNames[i]).split(";");
					for (int j=0; j<linkedFields.length; j++)
					{
%>

//		fieldsLinkedToExternalWebSites["<%= linkedFields[j] %>"] = "<%= lwsNames[i] %>";

<%
					}*/
				}
			}
%>

		function resizeDataTableContainer() {
			jQuery('.dataTableContainer').css("display", "none");
			jQuery('.dataTableContainer').css('width', (jQuery('#theTabberObj').width() - 20)+'px');
			jQuery('.dataTableContainer').css("display", "block");
		}

		jQuery(document).ready(function() {
			resizeDataTableContainer();
		});
		jQuery(window).resize(function() {
			resizeDataTableContainer();
		});
	</script>
	<link rel="shortcut icon" href="../images/favicon.ico">
</head>

<body link="black" alink="purple" style="overflow-y:hidden;">

<jsp:include page="topinc.jsp" flush="true"></jsp:include>
<jsp:include page="menu.jsp" flush="true"></jsp:include>

<%
String sErrorMsg = null;

ElementDocumentXml edx = null;
try
{
	edx = new ElementDocumentXml(sModulePath + "sortie.xml");
}
catch (NullPointerException npe)
{
	sErrorMsg = "This module is currently offline";
}

if (request.getHeader("User-Agent").contains("MSIE 9.0"))
	sErrorMsg = "This application is currently not compatible with Internet Explorer 9.<br>Please use <a href='http://support.microsoft.com/kb/956197' target='_blank'>compatibility view</a> or switch to another web-browser.";

if (sErrorMsg != null)
{
%>

	<br><br>
	<center>
	<h2><%= sErrorMsg %></h2>
	</center>

</body>
</html>

<%
	return;
}

ElementDocumentXml _edx = new ElementDocumentXml(sModulePath + "criteres.xml");
NodeList onglets = edx.racine.getElementsByTagName("onglet");
Element ongletElement, champElement;
int critere = 0, critereTd = 0, critereTr = 0;
Vector<Integer> vCritereTd = new Vector<Integer>(), vCritereTr = new Vector<Integer> ();
Vector<String> vString = new Vector<String>();
String sizeListe = "";
%>

<div id="div3" align="center">

<table border="0" width="100%">
<tr>
<td align='center'>
<div class="tabber" id="theTabberObj" style='width:90%; text-align:left;'>

   <%--#############################################################################################################################
   ################################################### BOUCLE QUI GENERE LES ONGLETS ###############################################
   #################################################################################################################################--%>

<%
HashMap<String, ArrayList<String>> selectFilterDependencies = new HashMap<String, ArrayList<String>>();
for(int l = 0; l < onglets.getLength(); l++)
{
	ongletElement = (Element) onglets.item(l);
	NodeList listChamps = edx.maList("champ",ongletElement);
%>

<div class="tabbertab" title="<%= ongletElement.getAttribute("nom") %>">
	<table border="0" width="100%">
		<tr>
			<td height="10" colspan="6"/>
		</tr>

<%-- BOUCLE QUI INITIALISE LES LIGNES DU TABLEAU SUR L'INTERFACE --%>

<%
	for (int champ = 0; champ < listChamps.getLength(); champ++)
	{
		champElement = (Element)listChamps.item(champ);
		critereTd++;
		critereTr++;
		if (champElement.getAttribute("visible").equals("1"))
		{
			// S'IL S'AGIT D'UNE ZONE DE TEXTE ON GARDE SA TRACE POUR LA RAJOUTER A LA FIN
			// POUR CONTOURNER LE PROBLEME D'AFFICHAGE AU MOMENT DE L'AUTO-COMPLETION
			if (champElement.getAttribute("style").equals("Text box"))
			{
				vCritereTd.addElement(critereTd);
				vCritereTr.addElement(critereTr);
				vString.addElement(champElement.getAttribute("nom"));
%>
		<tr id = <%= critereTr %>>
			<td width="15%" nowrap="nowrap"></td>
			<td width="15%" nowrap="nowrap" height="20" valign="top" align="right">
				<input type="hidden" value=<%= critereTd %>>
			 <label><%= champElement.getAttribute("nom").replaceAll(" ", "&nbsp;") %></label>

			</td>
			<td width="4%" valign="top" align="center">

<%
				if (champElement.getAttribute("suppressible").equals("1"))
				{
%>

				  <a onclick="supprimerLigne(this);" href="#">
					<img border="0" title="Remove" src="<%=sWebAppHome+"images/b_drop.png"%>">
				  </a>

<%				} %>

			</td>
			<td width="10%" align="center">

<%
				if (champElement.getAttribute("signe").equals("1"))
				{
%>

				<select id="signe" size="1">
					<option></option>
					<option value="&lt;=">&lt;=</option>
					<option value="&gt;=">&gt;=</option>
					<option value="=">=</option>
					<option value="&lt;">&lt;</option>
					<option value="&gt;">&gt;</option>
				</select>

<%
				}

				if (champElement.getAttribute("signe").equals("2"))
				{
%>

				<select id="signe" size="1">
					 <option value="<">&lt;</option>
				</select>

<%
				}

				if (champElement.getAttribute("signe").equals("3"))
				{
%>

				 <select id="signe" size="1">
					 <option value="&gt;">&gt;</option>
				 </select>

<%
				}

				if (champElement.getAttribute("signe").equals("4"))
				{
%>

				 <select id="signe" size="1">
					 <option value="=">=</option>
				 </select>

<%
				}

				if (champElement.getAttribute("signe").equals("5"))
				{
%>

				<select id="signe" size="1">
					 <option value="<=">&lt;=</option>
				</select>

<%
				}

				if (champElement.getAttribute("signe").equals("6"))
				{
%>

				<select id="signe" size="1">
					 <option value="&gt;=">&gt;=</option>
				</select>

<%
				}

				if (champElement.getAttribute("signe").equals("7"))
				{
%>

				<select id="signe" size="1">
					 <option value="like"><%=" like "%></option>
					 <option value="not like"><%=" not like "%></option>
				</select>

<%
				}

				if (champElement.getAttribute("signe").equals("8"))
				{
%>

				<select id="signe" size="1">
					 <option value="regexp"><%=" like "%></option>
					 <option value ="not regexp" ><%=" not like "%></option>
				</select>

<%				} %>

			</td>

<%
				if (champElement.getAttribute("autocompletion").equals("1"))
				{
%>

			<td width="100" nowrap="nowrap" valign="top" height="20" align="left">

<%-- L'ATTRIBUT "id" ICI EST UTILISE AU NIVEAU DE L'AUTOCOMPLETION POUR NE PAS CONFONDRE LES DIFFERENTES ZONES DE TEXTE --%>

				<input id=<%= champ %> class= <%=champElement.getAttribute("table")%> name=<%=champElement.getAttribute("id")%>
					type="text" <% if (champElement.hasAttribute("taille")){%>size=<%=champElement.getAttribute("taille")%>
<%
							} else if (!champElement.hasAttribute("taille") || !champElement.getAttribute("taille").equals(""))
							{%> size="20" <%}%>
							onkeydown="initAutoComplete(this,this.className,this.name);">
			</td>
<%
				}
				else
				{
%>

			<td width="100" nowrap="nowrap" valign="top" height="20" align="left">

<%-- L'ATTRIBUT "id" ICI EST UTILISE AU NIVEAU DE L'AUTOCOMPLETION POUR NE PAS CONFONDRE LES DIFFERENTES ZONES DE TEXTE --%>

				<input id=<%= champ %> class= <%=champElement.getAttribute("table")%> name=<%=champElement.getAttribute("id")%>
					type="text" <% if (champElement.hasAttribute("taille")){%>size=<%=champElement.getAttribute("taille")%>
<%
							} else if (!champElement.hasAttribute("taille") || !champElement.getAttribute("taille").equals(""))
							{%> size="20" <%}%>>
			</td>

<%				} %>

		</tr>

<%
			}
			else if (!champElement.getAttribute("style").equals("Text box"))
			{
%>

		<tr id = "<%= critereTr %>">

			<td width="15%" nowrap="nowrap"></td>
			<td width="15%" nowrap="nowrap" height="20" valign="top" align="right">
				<input type="hidden" value="<%= critereTd %>">
					<label><%= champElement.getAttribute("nom").replaceAll(" ", "&nbsp;") %></label>
			</td>
			<td width="4%" valign="top" align="center">

<%
				if (champElement.getAttribute("suppressible").equals("1"))
				{
%>

				  <a onclick="supprimerLigne(this);" href="#">
					<img border="0" title="Remove" src='<%=sWebAppHome+"images/b_drop.png"%>' alt=""/>
				  </a>

<%				} %>

			</td>

<%
				if (champElement.getAttribute("style").equals("Select box"))
				{
					if (!champElement.getAttribute("size").equals("1"))
					{
%>

			<td width="10%" valign="top" align="center">

<%
					}
					else
					{
%>

			</td><td width="10%" align="center">

<%
					}
				}
				else if (champElement.getAttribute("style").equals("Check boxes"))
				{
%>

			</td><td width="10%" valign="top" align="center">

<%
				}
				else
				{
%>

			</td><td width="10%" align="center">

<%
				}

				if (champElement.getAttribute("signe").equals("1"))
				{
%>

				<select id="signe" size="1">
					<option></option>
					<option value="&lt;=">&lt;=</option>
					<option value="&gt;=">&gt;=</option>
					<option value="=">=</option>
					<option value="&lt;">&lt;</option>
					<option value="&gt;">&gt;</option>
				</select>

<%
				}

				if (champElement.getAttribute("signe").equals("2"))
				{
%>

				<select id="signe" size="1">
					 <option value="<">&lt;</option>
				</select>

<%
				}

				if (champElement.getAttribute("signe").equals("3"))
				{
%>

				 <select id="signe" size="1">
					 <option value="&gt;">&gt;</option>
				 </select>

<%
				}

				if (champElement.getAttribute("signe").equals("4"))
				{
%>

				 <select id="signe" size="1">
					 <option value="=">=</option>
				 </select>

<%
				}

				if (champElement.getAttribute("signe").equals("5"))
				{
%>

				<select id="signe" size="1">
					 <option value="<=">&lt;=</option>
				</select>

<%
				}

				if (champElement.getAttribute("signe").equals("6"))
				{
%>

				<select id="signe" size="1">
					 <option value="&gt;=">&gt;=</option>
				</select>

<%
				}

				if (champElement.getAttribute("signe").equals("7"))
				{
%>

				<select id="signe" size="1">
					 <option value="like"><%=" like "%></option>
					 <option value="not like"><%=" not like "%></option>
				</select>

<%
				}

				if (champElement.getAttribute("signe").equals("8"))
				{
%>

				<select id="signe" size="1">
					 <option value="regexp"><%=" like "%></option>
					 <option value ="not regexp" ><%=" not like "%></option>
				</select>

<%				} %>


			</td>
			<td width="100" nowrap="nowrap" valign="top" height="20" align="left">

<%
				if (champElement.getAttribute("style").equals("Select box"))
				{
					champElement = (Element)listChamps.item(champ);

					NodeList liste1 = champElement.getElementsByTagName("valeur");
					if (champElement.hasAttribute("size") && !champElement.getAttribute("size").equals(""))
						sizeListe = champElement.getAttribute("size");
					else
						sizeListe = "1";

					String selectId = ongletElement.getAttribute("nom") + "." + champElement.getAttribute("table") + "." + champElement.getAttribute("nom").replaceAll(" ", "_");

					String sOptions = "<option></option>";
					for (int j = 0; j < liste1.getLength(); j++)
					{
						String sOptionAttributes = "";
						Element aVal = (Element) liste1.item(j);
						NamedNodeMap valAttributes = aVal.getAttributes();
						for (int k=0; k<valAttributes.getLength(); k++)
						{
							Attr attr = (Attr) valAttributes.item(k);
							String parentSelectId = ongletElement.getAttribute("nom") + "." + attr.getName();
							if (!selectFilterDependencies.containsKey(selectId))
								selectFilterDependencies.put(selectId, new ArrayList<String>());
							if (!selectFilterDependencies.get(selectId).contains(parentSelectId))
								selectFilterDependencies.get(selectId).add(parentSelectId);
						}
						sOptions += "<option>" + aVal.getTextContent() + sOptionAttributes + "</option>";
					}
%>

				<select id="<%= selectId %>" style='min-width:200px;' size=<%= sizeListe %> <%= "1".equals(sizeListe) ? "" : "multiple" %> onchange="filterSelectContentsForChildrenOf(this);">
					<%= sOptions %>
				</select>

<%
				}
				else if (champElement.getAttribute("style").equals("Check boxes"))
				{
					champElement = (Element)listChamps.item(champ);
					NodeList liste1 = champElement.getElementsByTagName("valeur");
%>

				<input type="checkbox" name="list" align="left" onclick="allChecked(this);"><b>Check/Uncheck_all</b><br>

<%
					for (int j = 0; j < liste1.getLength(); j++)
					{
%>

				<input type="checkbox" name="list" align="left" value="<%= liste1.item(j).getTextContent() %>">

				<%= liste1.item(j).getTextContent() %><br>

<%
					}
				}
%>

			</td>
		</tr>

<%
			}
		}
	}
%>

		<!-- LA LIGNE CACHEE QUI SERA RENDUE VISIBLE LORS DE L'AJOUT D'UN CRITERE -->
		<tr class=<%= l %>  style="display: none">
			<td width="15%" nowrap="nowrap"/>
			<td width="15%" nowrap="nowrap" height="20" valign="top" align="right"></td>
			<td width="4%" valign="top" align="center">
				<a onclick="supprimerLigne(this);" href="#">
					<img border="0" title="Remove" src="<%=sWebAppHome+"images/b_drop.png"%>">
			    </a>
			</td>
			<td width="10%" align="center">
			<td width="100" nowrap="nowrap" height="20" align="left"/>
		</tr>
		</table>

		<table border="0" width="100%">
		<tr>
			<td width="20%" align="left" style='font-weight:bold;'>
				OPERATOR :
				<input type="radio" name="operatorSelector<%= l %>" checked id="andOperator<%= l %>">
				<font color="#000000" face="verdana" size="1"><i>AND</i></font>
				<input type="radio" name="operatorSelector<%= l %>" id="orOperator<%= l %>">
				<font color="#000000" face="verdana" size="1"><i>OR</i></font>
			</td>
			<td colspan='5' align='right'>
				<select id='<%= ongletElement.getAttribute("nom")%>' size="1" onchange="ajouteLigne(this);">
					<option>[ Add criterion ]&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;</option>

<%-- REMPLIR LA LISTE DEROULANTE AVEC TOUS LES CRITERES --%>
<%
	for(int champ = 0; champ < listChamps.getLength(); champ++)
	{
		champElement = (Element)listChamps.item(champ);
		if (champElement.getAttribute("suppressible").equals("1"))
		{
%>

				<option value="<%= critere++ %>" title="<%= champElement.getAttribute("signe")%>"><%= champElement.getAttribute("nom")%></option>

<%
		}
	}
%>
				</select>
				&nbsp;
				<div width="100%" style="position:relative; display:inline;">
					<div style="text-align:center; position:absolute; display:none; z-index:5; width:100%; left:0px; top:-4px; background-color:#DAEBF3;" id="progressBarDiv<%= l %>B">
						<img src="<%= sWebAppHome%>images/progressBarLong.gif">
					</div>
					<input type="button" value="Search now" onclick="backwardFirstPage();">
					<input type="button" value="Reset form" onclick="reset();">
				</div>
			</td>
		</tr>
		</table>

		<table border="0" align="left" width="100%" class="navigationBar" id="navigationBar<%= l %>">
		<tr>
			<td height="1"></td>
		</tr>
		<tr>
			<td nowrap align="left" width='25%'><label class="label_resultat"><u>RESULTS</u> :</label><label id="nombre_de_ligne"></label></td>
			<td nowrap align="right" width='55%'>
				<input id="navButtonFirst<%= l %>" type="button" value=" &lt;&lt; " disabled="disabled" onclick="backwardFirstPage();">
				<input id="navButtonPrevious<%= l %>"	type="button" value=" &lt; " disabled="disabled" onclick="backwardParPage();">
				<label>Page n</label><input type='text' id="numeroPage<%= l %>" value="1" onchange="fixIntValue(this, parseInt(document.getElementById('nbOfPages<%= l %>').innerHTML), 1); retrieveDataForActiveTab();" maxlength='4' style="width:30px; text-align:center;"> /<label id="nbOfPages<%= l %>"></label>
				<input id="navButtonNext<%= l %>" type="button" value=" &gt; " onclick="forwardParPage();">
				<input id="navButtonLast<%= l %>" type="button" value=" &gt;&gt; " onclick="forwardLastPage();">
				&nbsp;&nbsp;<label>Number of records per page</label>
				<input type="text" id="record<%= l %>" value="50" maxlength='3' style="width:25px; text-align:center;" onchange="fixIntValue(this, _nbrTotalEnregistrement, 50); backwardFirstPage();">
			</td>
			<td nowrap align="right" width='18%'>

<%
	boolean fCanExportAsMatrix = false;
	try
	{
		String[] matrixExportDetails = TextConstants.get(sModule + "_MatrixExport_" + ongletElement.getAttribute("nom")).split(";");
		if (matrixExportDetails.length == 3)
			fCanExportAsMatrix = true;
	}
	catch (java.util.MissingResourceException ignored)
	{}
%>

				<select id="listeExportation<%= l %>">
					<option value="">[Export results]</option>
					<option value='excel'>Excel</option>
					<%= fCanExportAsMatrix ? "<option value='excelM'>Excel (matrix)</option>" : "" %>
					<option value='text'>Text</option>
					<%= fCanExportAsMatrix ? "<option value='textM'>Text (matrix)</option>" : "" %>
				</select>
			</td>
			<td nowrap align="left" width='2%'>
				<button onclick="exporter(document.getElementById('listeExportation<%= l %>').value);"><img src="<%=sWebAppHome+"images/go.gif"%>" border='0'></button>
			</td>
		</tr>
		<tr>
			<td height="1"></td>
		</tr>
		</table>

		<br><br><br><br><br>

		<div style="overflow-y:auto;" class="dataTableContainer">
		<table id="dataTable<%= l %>" cellspacing='1' cellpadding='1' align="left" border="0" style="margin-top:25px; width:100%; visibility:hidden; background-color:#fff;">
		  <tr>
				<td height="1"></td>
		  </tr>
		  <tr>
				<td height="1"></td>
		  </tr>
		  <tr>
				<td height="1"></td>
		  </tr>
          <tr id="th" height="22" valign='top'>
			 <th align="left"></th>
		  </tr>
		</table>
		</div>
	</div>

<%
}

//###############################################	partie onglet non dynamique #########################
/*for(int r=0;r<_edx.racine.getChildNodes().getLength();r++)
{
	if((_edx.racine.getChildNodes().item(r).getNodeName()).compareToIgnoreCase("onglet_supp")==0)
	{
		NodeList _onglets = _edx.racine.getElementsByTagName("onglet_supp");
	}
}*/
%>

  </div>
  </td>
  </tr>
 </table>
<br>
<br>
</div>

<div style='width:90%; background-color:red; position:absolute; top:230px; left:5%; visibility:hidden;'>
<div style="visibility:visible; text-align:right; position:absolute; display:none; z-index:5; width:100%; left:-35px;" id="progressBarDivT">
	<img src="<%= sWebAppHome%>images/progressBarLong.gif">
</div>
<div id="topButtons" style='float:right; margin-right:20px; visibility:visible;'>
	<input type="button" value="Search now" onclick="backwardFirstPage();">
	<input type="button" value="Reset form" onclick="reset();">
</div>
</div>

<form id="exportForm" accept-charset="UTF-8" action="<%= sWebAppHome + "SearchServlet" %>?module=<%= sModule %>" method="post"></form>

<script language="javascript">
var selectFilterDependencies = new Array();

<%
	String[] keys = selectFilterDependencies.keySet().toArray(new String[selectFilterDependencies.size()]);
	for (int i=0; i<keys.length; i++)
	{
%>

		selectFilterDependencies["<%= keys[i] %>"] = new Array();

<%
		ArrayList<String> dependentSelects = selectFilterDependencies.get(keys[i]);
		for (int j=0; j<dependentSelects.size(); j++)
		{
%>

		selectFilterDependencies["<%= keys[i] %>"][selectFilterDependencies["<%= keys[i] %>"].length] = "<%= dependentSelects.get(j) %>";

<%
		}
	}
%>
</script>

</body>
</html>