<%@ page language="java" contentType="text/html; charset=ISO-8859-1" pageEncoding="ISO-8859-1" import="java.sql.DriverManager,java.sql.Connection,fr.cirad.tropgene.*,javax.xml.parsers.*,org.w3c.dom.*,java.io.*"%>

<%
	String sModule = request.getParameter("module");
	String sModulePath = ModuleListManager.getModuleConfigPath(sModule)+ File.separator;
	String fichier = sModulePath + "criteres.xml";

	String driverSGBD = request.getParameter("driver_sgbd_name");
	String driver = request.getParameter("driver_name");
	String domain = request.getParameter("domain_name");
	String bd = request.getParameter("database_name");
	String password = request.getParameter("password_name");
	String login = request.getParameter("login_name");
	String onglet = request.getParameter("onglet");

	try
	{
		if (new ElementDocumentXml(fichier).nomOnglets().contains(onglet))
			throw new Exception("This search-form name is already being used: " + onglet);

		Class.forName(driverSGBD).newInstance();
		DriverManager.getConnection(driver + "//" + domain + "/" + bd, login, password);
	}
	catch (Exception e)
	{
%>

	<html><head><script language="Javascript">alert("<%= e.getMessage() %>"); history.back();</script></head><body></body></html>

<%
		return;
	}

	//CONSTRUCTION DU DOCUMENT XML
	DocumentBuilderFactory fabrique = DocumentBuilderFactory.newInstance();
	DocumentBuilder constructeur = fabrique.newDocumentBuilder();
	File xml = new File(fichier);
	Document document = constructeur.parse(xml);

	// PROPRIETES DU DOM
	document.setXmlVersion("1.0");
	document.setXmlStandalone(true);

	Element racine = document.getDocumentElement();

	//####################################ONGLET################################################

	Element balise_onglet = document.createElement("onglet");
	String onglet_name = "nom";
	balise_onglet.setAttribute(onglet_name, onglet);
	racine.appendChild(balise_onglet);

	Element balise_driver_sgbd = document.createElement("driver_SGBD");
	String driver_sgbd_name = "nom";
	balise_driver_sgbd.setAttribute(driver_sgbd_name, driverSGBD);
	balise_onglet.appendChild(balise_driver_sgbd);

	Element balise_driver = document.createElement("driver");
	String driver_name = "nom";
	balise_driver.setAttribute(driver_name, driver);
	balise_onglet.appendChild(balise_driver);

	Element balise_domain = document.createElement("domaine");
	String domain_name = "domain";
	balise_domain.setAttribute(domain_name, domain);
	balise_onglet.appendChild(balise_domain);

	Element balise_database = document
	.createElement("base_de_donnees");
	String database_name = "base";
	balise_database.setAttribute(database_name, bd);
	balise_onglet.appendChild(balise_database);

	Element balise_login = document.createElement("login");
	String login_name = "log";
	balise_login.setAttribute(login_name, login);
	balise_onglet.appendChild(balise_login);

	Element balise_pwd = document.createElement("password");
	String password_name = "pass";
	balise_pwd.setAttribute(password_name, password);
	balise_onglet.appendChild(balise_pwd);

	Util.transformerXml(document,fichier, true);

	String sRedirectionURL =	"modifOnglet.jsp"
					 + "?module=" + java.net.URLEncoder.encode(sModule, "UTF-8")
					 + "&onglet=" + java.net.URLEncoder.encode(onglet, "UTF-8")
					 + "&new_driver_sgbd_name=" + java.net.URLEncoder.encode(driverSGBD, "UTF-8")
					 + "&new_driver_name=" + java.net.URLEncoder.encode(driver, "UTF-8")
					 + "&new_domain_name=" + java.net.URLEncoder.encode(domain, "UTF-8")
					 + "&new_password_name=" + java.net.URLEncoder.encode(password, "UTF-8")
					 + "&new_login_name=" + java.net.URLEncoder.encode(login, "UTF-8")
					 + "&database_name=" + java.net.URLEncoder.encode(bd, "UTF-8");

	response.sendRedirect(sRedirectionURL);
%>