<%@ page language="java" contentType="text/html; charset=ISO-8859-1" pageEncoding="ISO-8859-1" import="fr.cirad.tropgene.*,javax.xml.parsers.*,org.w3c.dom.*,java.io.*,java.sql.*" %>

<%
	String sAppRoot = "../";
%>

<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN" "http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<meta http-equiv="Content-Type" content="text/html; charset=ISO-8859-1">
<link media="screen" type="text/css" href="../CSS/authentifier.css" rel="StyleSheet"/>
<link media="screen" type="text/css" href="../CSS/interface.css" rel="StyleSheet"/>
<link media="screen" type="text/css" href="../CSS/choixCriteres.css" rel="StyleSheet"/>
<script language="JavaScript" type='text/javascript'>
//###################################################################################################
//########################################JAVASCRIPT#################################################
//###################################################################################################

function getRadioGroupValue(Obj_checkBoxGroup)
{
	if (Obj_checkBoxGroup.length == null)
		return Obj_checkBoxGroup.value;
                 
	for (j=0; j<Obj_checkBoxGroup.length; j++)
	      if (Obj_checkBoxGroup[j].checked)
	              return Obj_checkBoxGroup[j].value;                        
 	return null;               
}
    
//###################################################################################################
//############################################## COOKIES ############################################

function ecrireCookie(nom,id)
{
	document.cookie=nom+"="+id+"!";
}

function lireCookie(nom)
{	
	var cookValue = "";
	egal = document.cookie.indexOf("=") ;
	var cookName = document.cookie.substring (0, egal) ;
	var point_virgule = document.cookie.indexOf("!") ;
	if (cookName == nom)
	{
		cookValue = document.cookie.substring(egal+1,point_virgule);
		document.getElementById(cookValue).checked = true;
	}
	else if (document.forms[0].module != null)
	{
		if	(document.forms[0].module.length == null)
			document.forms[0].module.checked = true;
		else
			document.forms[0].module[0].checked = true;
	}
}
//###################################################################################################
//##################################### FONCTION DEGRISANT LES BOUTONS  #############################
window.onload= function()
{	
	lireCookie("selectedModule");

	var _selectedModule = document.getElementsByName("selectedModule");
	for(u=0;u<_selectedModule.length;u++)
	{
		var id=_selectedModule[u].getAttribute("id");
		if (document.getElementById(id).checked)
		{
			document.getElementById("voirFichier").disabled=false;
			document.getElementById("modifFichier").disabled=false;
			document.getElementById("SuppFichier").disabled=false;
			
			chemin = document.getElementById(id).value;
			_fonction(id);		
		}
	}
	
	checkOutputDate();
}

//######################## APPEL DE LA FONCTION ASSOCIEE AU BOUTON RADIO ############################
function _fonction(_id)
		{
	url=_id;
	urlFichier=url+"/criteres.xml";
	_url=_id;

	}

//###################################################################################################
function getXhr()
{
	  var xhr = null; 
		if(window.XMLHttpRequest) // Firefox et autres
		   xhr = new XMLHttpRequest(); 
		else if(window.ActiveXObject)
		{ // Internet Explorer 
		   	try 
		   	{
	          xhr = new ActiveXObject("Msxml2.XMLHTTP");
	      } 
        catch (e) 
        {
	            xhr = new ActiveXObject("Microsoft.XMLHTTP");
	      }
		}
		else 
		{ // XMLHttpRequest non support par le navigateur 
		   alert("Your browser does not support XMLHTTPRequest"); 
		   xhr = false; 
		} 		
          return xhr;	
}

//##################################################################################################
//##################################### VOIR FICHIER CRITERES.XML ##################################
function voirFichierCriteres()
{	
	window.open("<%= sAppRoot %>ModuleListManager?action=<%= ModuleListManager.ACTION_VIEW_CRITERIA %>&module=" + getRadioGroupValue(document.forms[0].module));
}
//##################################################################################################
//##################################### AJOUT ONGLET FICHIER CRITERES.XML ##########################
function ajoutOnglet()
{	
	document.getElementById("choix").value="";
	document.forms[0].submit();
}
//##################################################################################################
//############################ MODIFICATION D ONGLET FICHIER CRITERES.XML ##########################
function modifOnglet()
{
	document.getElementById("choix").value="b";
	document.forms[0].submit();
}
//##################################################################################################
//##################### SUPPRESSION D ONGLET FICHIER CRITERES.XML ##################################
function suppOnglet()
{
	document.getElementById("choix").value="c";
	document.forms[0].submit();
}
//###################################################################################################
//############################ FONCTION SUPPRIMANT LE FICHIER CRITERES.XML ##########################
function removeFile()
{	
	var confirmation = confirm("Do you really want to empty the search criteria file?");
	if (confirmation == true)
	{
		 var xhr = getXhr();  
		 xhr.open("POST", "<%= sAppRoot %>ModuleListManager?action=<%= ModuleListManager.ACTION_EMPTY_CRITERIA %>&module=" + getRadioGroupValue(document.forms[0].module), true); 
		 xhr.setRequestHeader("Content-Type", "application/x-www-form-urlencoded");
		 xhr.send("");   			
	}	
}

//###################################################################################################
//############################ FONCTION GENERANT LE FICHIER SORTIE.XML ##########################
function generateOuput()
{	
	var confirmation = confirm("Do you really want to overwrite contents of the search interface file?");
	if (confirmation == true)
	{
		 document.getElementById("outputNotUpToDateMsg").innerHTML = "<img src='../images/progressBarLong.gif'>";
		 
		 // we launch this in the background otherwise some browsers like Chrome don't even show the progress bar
		 setTimeout("doGenerateOuput()", 1);
	}
}

function doGenerateOuput()
{	
	 var xhr = getXhr();  
	 xhr.open("POST", "<%= sAppRoot %>ModuleListManager?action=<%= ModuleListManager.ACTION_GENERATE_OUTPUT %>&module=" + getRadioGroupValue(document.forms[0].module), false); 
	 xhr.setRequestHeader("Content-Type", "application/x-www-form-urlencoded");
	 xhr.send(null);   	
	 if (xhr.responseText.length > 0)
	 	alert(xhr.responseText);	/* sinon c'est qu'il n'y a pas eu d'erreur */
	 checkOutputDate();
}

//#############################################################################
//############# METHODE QUI VERIFIE SI SORTIE.XML SEMBLE ETRE A JOUR ##########
//#############################################################################
function checkOutputDate()
{	
	var xhr = getXhr();  	
  	xhr.open("POST", "<%= sAppRoot %>ModuleListManager?action=<%= ModuleListManager.ACTION_CHECK_OUTPUT_DATE %>&module=" + getRadioGroupValue(document.forms[0].module), false); 
	xhr.setRequestHeader("Content-Type", "application/x-www-form-urlencoded");
	xhr.send(null);
	document.getElementById("outputNotUpToDateMsg").innerHTML = xhr.responseText;
}

//###################################################################################################
//##############################################FIN JAVASCRIPT#######################################
//###################################################################################################
</script>
</head>

<body>

<jsp:include page="topinc.jsp" flush="true" />

<form name="formul" action="../JSP/criterion.jsp" method="POST">
<input type='hidden' name='choix' id='choix'>
<table border="0" align="center" >
	<tr>
		<td height="10"/>
	</tr>
	<tr>
		<td>
			<table>
			<tbody>
			<tr>
				<td>
					<table style="width: 800px;" cellspacing="0" border="0" >
					<tbody>
					<tr>
						<td class="default_top_left"/>
<%--############################### --%>
						<td class="default_top"></td>
						<td class="default_top_right"/>
					</tr>
					
					
					<tr>
						<td class="default_left"/>
						<td class="default_center">
						
					<table frame="void" rules="cols" width="100%">
							<tbody>
							<tr>
								<td width="33%" align="left">
									<table>
<%
														String[] moduleNames = ModuleListManager.getAvailableModules();
														if (moduleNames.length == 0)
														{
%>
									<tr><td>
									AUCUNE PLANTE N'EST GEREE PAR CETTE APPLICATION ACTUELLEMENT
									<br><br>
									<input type="button" value="Retour" onclick="history.back();">
									</td></tr>

<%
														}
														else
															for(int a=0; a<moduleNames.length; a++)
															{
																String url = sAppRoot + "?module=" + moduleNames[a];
%>

									<tr>
										<td><input style='margin-bottom:5px;' type="radio" value="<%= moduleNames[a] %>" name="module" id="<%= moduleNames[a] %>" onClick="ecrireCookie('selectedModule','<%= moduleNames[a] %>'); checkOutputDate();"></td>
										<td><%= moduleNames[a] %></td>
										<td><a href="interface.jsp?module=<%= moduleNames[a] %>" title="Consulter ce module" target="_blank"><img border='0' src="../images/magnifier.gif"></img></a></td>
									</tr>

<%															} %>
									</table>	
								</td>
								
								<td width="34%" align="center" height="200">
									
										<table style='display:<%= moduleNames.length == 0 ? "none" : "inline" %>;'>
											<tr>
												<td>
												<input type="button" id="voirFichier" value="Consult search criteria file" onClick="voirFichierCriteres()" >
												</td>
											</tr>
											<tr>
												<td>
												<br>
												<b>Search criteria modification:</b><br>
													<input style='margin-top:5px;' type='button' value="Add a search form" onclick='ajoutOnglet();'><br>
													<input type='button' value="Edit a search form" onclick='modifOnglet();'><br>
													<input type='button' value="Delete a search form" onclick='suppOnglet();'><br>
												<br>
												</td>
											</tr>
											<tr>
												<td>	
												<input type="button" id="SuppFichier" value="Empty search criteria file" onClick="removeFile();">
												</td>
											</tr>
									</table>
									
								</td>
								<td width="33%" align="right">
									<input type="button" value="Manage detail sheets" onClick="location.href='modifLinkFile.jsp?module=' + getRadioGroupValue(document.forms[0].module);">
									<br><br><hr><br>
									<b>Search interface file generation</b>
									<br>(Contains data that the search interface consists of, built using rules defined in the search criteria file to get all required entries from the database)
									<br><br>
									<input type="button" value="Generate now" onClick="generateOuput();">
									<p style='color:#F2961B; font-weight:bold; height:25px;' id='outputNotUpToDateMsg'></p>
								</td>								
							</tr>
							
							</tbody>
					</table>
					</td>
					
					
						<br>
						<td class="default_right"></td>
					</tr>
					<tr>
						<td class="default_bottom_left"></td>
						<td class="default_bottom"></td>
						<td class="default_bottom_right"></td>						
					</tr>
					</tbody>					
				</table>
				</td>
				<td style="width: 10px;">
				</td><td></td>
			</tr>
			</tbody>
			</table>
		</td>
	</tr>
 </table>
 
</form>
							  
</body>
</html>