<%@ page import="fr.cirad.tropgene.*,javax.xml.parsers.*,org.w3c.dom.*,java.io.*,java.sql.*,java.util.regex.*,java.util.*" %>

<%
	String sModule = request.getParameter("module");
	String modulePath = ModuleListManager.getModuleConfigPath(sModule) + File.separator;
%>

<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN" "http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
	<meta http-equiv="Content-Type" content="text/html; charset=ISO-8859-1">
	<title>TropGene</title>
	<link media="screen" type="text/css" href="../CSS/authentifier.css" rel="StyleSheet" />
	<link media="screen" type="text/css" href="../CSS/formulaire.css" rel="StyleSheet" />
	<link media="screen" type="text/css" href="../CSS/interface.css" rel="StyleSheet"/>

	<script type="text/javascript">
	//###################################################################################################
	//####################################### JAVASCRIPT ################################################
	//###################################################################################################

	//########################### FONCTION PERMETTANT LES PARAMTRES DE L ONGLET #########################
	window.onload = function()
	{
		if(document.getElementById("id_onglet") && document.getElementById("id_onglet").options[document.getElementById("id_onglet").selectedIndex].text!="")
			getParamConnexion();

		if(document.getElementById("id_onglet_ajout"))
			document.getElementById("id_onglet_ajout").focus();
	}

	document.onkeyup = function()
	{
			if (window.event != null && (window.event.keyCode == 13 || window.event.keyCode == 3))
				verif(formulaire_critere);
	}
	function getXhr()
	{
		  var xhr = null;
			if(window.XMLHttpRequest) // Firefox et autres
			xhr = new XMLHttpRequest();
			else if(window.ActiveXObject)
			{ // Internet Explorer
			   	try
			   	{
		           xhr = new ActiveXObject("Msxml2.XMLHTTP");
		      }
	        catch (e)
	        {
		            xhr = new ActiveXObject("Microsoft.XMLHTTP");
		      }
			}
			else
			{ // XMLHttpRequest non support par le navigateur
			   alert("Your browser does not support XMLHTTPRequest");
			   xhr = false;
			}
	         return xhr;
	}
	//#################################### VERIFICATION FORMULAIRE ########################################

	function verif()
	{

			if(document.getElementById("id_onglet"))
			{
		 		if(document.getElementById("id_onglet").options[document.getElementById("id_onglet").selectedIndex].text=="")
		  		{
		  			alert("Please fill-in field 'Onglet' !");
			  		document.getElementById("id_onglet").options[document.getElementById("id_onglet").selectedIndex].focus();
			 		return;
		  		}

			}
			if(document.getElementById("id_onglet_ajout"))
			{
		 		if(document.getElementById("id_onglet_ajout").value=="")
		  		{
		  			alert("Please fill-in field 'Onglet' !");
			  		document.getElementById("id_onglet_ajout").focus();
			 		return;
		  		}

			}
			if(document.getElementById("id_onglet_ajout"))
			{
				onglet_value=document.getElementById("id_onglet_ajout").value;
				onglet=onglet_value.toString();

				if (onglet.indexOf(" ",0)>0 || onglet.charAt(0) == " ")
				{
					alert("Leading / trailing spaces not allowed in search form name");
					document.getElementById("id_onglet_ajout").focus();
					return;
				}

<%
				List<String> _onglet = new ElementDocumentXml(modulePath + "criteres.xml").nomOnglets();

				for(int t=0;t< _onglet.size();t++)
				{
					String onglet_fichier = _onglet.get(t).toLowerCase();
%>

					onglet = onglet.toLowerCase();
					if(onglet==( "<%=onglet_fichier%>"))
					{
						alert("Please provide another search form name. This one is already being used.");
						document.getElementById("id_onglet_ajout").focus();
						return;
					}

<%				} %>

			}

			if (document.getElementById("driver_sgbd_value").value == "")
			{
				alert("Please fill-in field 'Driver_SGBD' !");
				document.getElementById("driver_SGBD_value").focus();
				return;
			}

			if (document.getElementById("driver_value").value == "")
			{
				alert("Please fill-in field 'Driver' !");
				document.getElementById("driver_value").focus();
				return;
			}
			if (document.getElementById("domain_value").value == "")
			{
				alert("Please fill-in field 'domain' !");
				document.getElementById("domain_value").focus();
				return;
			}

			if(document.getElementById("database_value"))
			{
			  if (document.getElementById("database_value").options[document.getElementById("database_value").selectedIndex].text=="")
			  {
			  	alert("Please fill-in field 'database' !");
				  document.getElementById("database_value").options[document.getElementById("database_value").selectedIndex].focus();
				 return;
			  }
			}

			if (document.getElementById("login_value").value == "")
			{
				alert("Please fill-in field 'login' !");
				document.getElementById("login_value").focus();
				return;
			}

			if (document.getElementById("password_value").value == "")
			{
				alert("Please fill-in field 'password' !");
				document.getElementById("password_value").focus();
				return;
			}

			if( document.getElementById("database_value_text"))
			{
				onglet=document.getElementById("id_onglet").options[document.getElementById("id_onglet").selectedIndex].text;
				var confirmation = confirm("Do you really want to remove search form "+onglet+"?");
				if (confirmation == true)
				{
					document.forms[0].submit();
				}
			}
			else
			{
				document.forms[0].submit();
			}
	}
	//################################### FONCTION PEMETTANT DE RECUPERER LES PARAMETRES D UN ONGLET #########################
	function getParamConnexion()
	{
	 	   onglet = document.getElementById("id_onglet").options[document.getElementById("id_onglet").selectedIndex].text;
		   if (onglet == '')
		   		return;

		   var xhr = getXhr();
		   xhr.onreadystatechange = function()
		   {
			   if (xhr.readyState == 4)
			   {
				   if (xhr.status == 200)
				   {
					   leselect2 = xhr.responseText;
					   var regExpBeginning = /^\s+/;
					   select=leselect2.replace(regExpBeginning,"");
					   select3=select.split("\n");
					   document.getElementById("driver_sgbd_value").value =select3[0];
					   document.getElementById("driver_value").value =select3[1];
					   document.getElementById("domain_value").value =select3[2];
					   if ( document.getElementById("id_old_database"))
					   {
					       document.getElementById("id_old_database").value =select3[3];
					   }
					   if( document.getElementById("database_value_text"))
					   {
					       document.getElementById("database_value_text").value=select3[3];
					   }
					   if( document.getElementById("database_value"))
					   {
					       liste_bd=select3[6];
						   bd=liste_bd.split(";");
						   for(var a=0;a<bd.length;a++)
						   {

							   		document.getElementById("database_value").options[a] = new Option(bd);
							   		document.getElementById("database_value").options[a].text =bd[a];
							   		if(bd[a]==select3[3])
							   		{
							   			 document.getElementById("database_value").options[a].selected=true;
							   		}
						   }
					   }
					   document.getElementById("login_value").value =select3[4];
					   document.getElementById("password_value").value =select3[5];

					   if (document.getElementById("id_onglet").options[0].text == '')
					   		document.getElementById("id_onglet").remove(0);
				  }
				  else
				  {
			       		alert("AJAX request encountered a problem");
				  }
			  }
		  }

		  onglet = document.getElementById("id_onglet").options[document.getElementById("id_onglet").selectedIndex].text;

		  xhr.open("POST","../JSP/getInfosXml.jsp?module=<%= sModule %>", true);
		  xhr.setRequestHeader("Content-Type", "application/x-www-form-urlencoded");

 		  xhr.send("onglet="+onglet);
	}
	//####################################################################################################################
	//###################################### FONCTION MODIFIANT L'URL DE REDIRECTION #####################################
	function modifUrl()
	{

		document.getElementById("url").value="../JSP/criterion.jsp?choix=c&module=<%= sModule %>";
	}
	//#####################################################################################################################
	//##############################################FIN JAVASCRIPT#########################################################
	//#####################################################################################################################
	</script>
</head>

</head>

<body>

<jsp:include page="topinc.jsp" flush="true" />

 <center>
 <table border="0">
	<tr>
		<td height="10"/>
	</tr>
	<tr>
		<td>
<%--#########################################################################--%>
<%--                            FORMULAIRE                                    --%>
<%--######################################################################### --%>
<%
		String action = null;
		String titre = null;

		File fichier = new File(modulePath + "connexion_default.xml");

		String valeur_choix= null;
		valeur_choix = request.getParameter("choix");
		if ("c".equals(valeur_choix))
		{
			action = "../JSP/removeNodeXml.jsp";
		}
		else if ("b".equals(valeur_choix))
		{
			action = "../JSP/modifOnglet.jsp";
		}
		else
		{
			action = "../JSP/addNodeXml.jsp";
		}
%>

		<form name="formulaire_critere" action="<% out.print(action) ;%> " method="post" onSubmit='false'>
		<input type='hidden' name='module' value='<%= sModule %>'>

			<table>
			<tbody>
			<tr>
				<td>
					<table style="width: 400px;" cellspacing="0" border="0">
					<tbody>
					<tr>
						<td class="default_top_left" width="20%"/>
<%--############TITRE################## --%>

<%
		if (valeur_choix.equals("b"))
		{
			titre="Editing a search form";
		}
		else if (valeur_choix.equals("c"))
		{
			titre="Deleting a search form";
		}
		else
		{
			titre="Adding a search form";
		}
%>

						<td class="default_top">
							<%= titre %>
						</td>
						<td class="default_top_right"/>
					</tr>
					<tr>
						<td class="default_left"/>
						<td class="default_center">
						<br>
						<table>
							<tbody>
<%
								if (!valeur_choix.equals(""))
								{
							%>
								<tr>
<%--######################--%>
								<td>Search form</td>
								<td>
								<SELECT name="onglet" id="id_onglet" onChange="getParamConnexion();" >
								<OPTION >  </OPTION>
<%
	try
	{
					//PARSE FICHIER CRITERES.XML
					DocumentBuilderFactory fabrique = DocumentBuilderFactory.newInstance();
				    DocumentBuilder constructeur = fabrique.newDocumentBuilder();

				    File xml = new File(modulePath + "criteres.xml");
				    Document document = constructeur.parse(xml);

				 	// PROPRIETES DU DOM
				    document.setXmlVersion("1.0");
				    document.setXmlStandalone(true);
				    //CREATION DE L ARBORESCENCE DU DOM
				    Element racine = document.getDocumentElement();
				    NodeList onglet = racine.getElementsByTagName("onglet");
					//pour chaque onglet
					for(int i=0; i<onglet.getLength(); i++)
					{
					     Element e = (Element)onglet.item(i);
					     if (e.hasAttribute("nom"))
					     {
				     		String valeur_onglet=e.getAttribute("nom");
%>
											<OPTION value="<%out.println(valeur_onglet);  %> "> <% out.println(valeur_onglet); %> </OPTION>
<%
									     }
									}
								}
								catch(Exception e)
								{
										e.printStackTrace();
										e.getMessage();
								}
%>
								</SELECT>
								</td>
								<td style="width: 140px;">
								</td>
								</tr>
<%
								}
								else
								{
%>
									<tr>
<%--######################--%>
										<td>Search form</td>
										<td>
											<input type="text" name="onglet" id="id_onglet_ajout">
										</td>
									</tr>

<%
								}
%>
								<tr>
<%--####################--%>
								<td>Driver_SGBD</td>
								<td>
<%
								//parse connexion_default.xml
								String driver_SGBD = new Parse(fichier).getDriverSGBD();
								String driver=new Parse(fichier).getDriver();
								String domain =new Parse(fichier).getDomain();
								String database=new Parse(fichier).getDatatabase();
								String password =new Parse(fichier).getPassword();
								String login=new Parse(fichier).getLogin();
								try
								{

									if (!valeur_choix.equals(""))
									{
%>
										<input type="text"  id="driver_sgbd_value" name="new_driver_sgbd_name" value="" onFocus="this.select();">
										<input type="hidden" value="<%= driver_SGBD %>"  name="driver_sgbd_name" >
<%
									}
									else
									{	//parse le fichier connexion_default afin de modifier la valeur des paramtres de connexion
%>
										<input type="text" value="<%= driver_SGBD %>" id="driver_sgbd_value" name="driver_sgbd_name" onFocus="this.select();">
<%
									}
								}
								catch(Exception e)
								{
									System.out.print(e.getMessage());
								}
%>
								</td>
								<td style="width: 140px;">
								</td>
								</tr>
								<tr>
<%--###############--%>
								<td>Driver</td>
								<td>
<%
								try
								{
									if (!valeur_choix.equals(""))
									{
%>
										<input type="text" value="" id="driver_value" name="new_driver_name" onFocus="this.select();">
										<input type="hidden" value="<%= driver %>"  name="driver_name" >
<%
									}
									else
									{
%>
										<input type="text" value="<%= driver %>" id="driver_value" name="driver_name" onFocus="this.select();">
<%
									}
								}
								catch(Exception e)
								{
									System.out.print(e.getMessage());
								}
%>
								</td>
								<td style="width: 140px;">
								</td>
								</tr>
								<tr>
<%--##############--%>
								<td>Domain</td>
								<td>
<%
								try
								{
									if (!valeur_choix.equals(""))
									{
%>
										<input type="text" value="" id="domain_value" name="new_domain_name" onFocus="this.select();" >
										<input type="hidden" value="<%= domain %>"  name="domain_name" >
<%
									}
									else
									{
%>
										<input type="text" value="<%= domain %>" id="domain_value" name="domain_name"  onFocus="this.select();">
<%
									}
								}
								catch(Exception e)
								{
									System.out.print(e.getMessage());
								}
%>
								</td>
								<td style="width: 140px;">
								</td>
								</tr>
								<tr>
<%--#####################--%>
								<td>Database</td>
								<td>
<%
								try
								{
									if (!valeur_choix.equals("") )
									{
										if(valeur_choix.compareToIgnoreCase("c")==0)
										{
%>
											<input type="text" id="database_value_text" >
<%
										}
										else
										{
%>
											<input type="hidden" name="old_database" value="" id="id_old_database">
											<SELECT name="database_name" id="database_value">
											<option ></option>
											</SELECT>
<%
										}
									}
									else
									{
										Class.forName("org.gjt.mm.mysql.Driver").newInstance();

										Connection connect = null;
										try
										{
											connect = DriverManager.getConnection(""+driver+"//"+domain+"/",login,password);
										}
										catch (Exception e)
										{
											org.apache.log4j.Logger.getRootLogger().debug(e);
										}

%>
										<input type="hidden" name="old_database" value="" id="id_old_database">
										<SELECT name="database_name" id="database_value" style="width:122px;">
										<option><%= connect == null ? "[ connection impossible ]" : "" %></option>

<%
										if (connect != null)
										{
											DatabaseMetaData meta = connect.getMetaData();
											ResultSet res = meta.getCatalogs();
											while (res.next())
											{
													String database_name = res.getString("TABLE_CAT");
													if(database==null)
													{
%>
													<OPTION> <%= database_name %> </OPTION>
<%
													}
													else
													{
													    Pattern p = Pattern.compile("^"+database+"");
														Matcher m =p.matcher(database_name);
														while(m.find())
														{
%>
														<OPTION> <%= database_name %> </OPTION>
<%
														}
													}
											}
											res.close();
											connect.close();
									    }
%>
										</SELECT>
										</td>
<%
									}
								}
								catch(Exception e)
								{
									System.out.println("message"+e.getMessage());
								}
%>
								<td style="width: 140px;">
								</td>
								</tr>
								<tr>
<%--######################--%>
								<td>Login</td>
								<td>
<%
								try
								{
									if (!valeur_choix.equals(""))
									{
%>
										<input type="text" id="login_value" value="" name="new_login_name" onFocus="this.select();">
										<input type="hidden" value="<%= login %>" name="login_name" >
<%
									}
									else
									{
%>
										<input type="text" id="login_value" value="<%= login %>" name="login_name" onFocus="this.select();">
<%
									}
								}
								catch(Exception e)
								{
									System.out.print(e.getMessage());
								}
%>
								</td>
								<td style="width: 140px;">
								</td>
								</tr>
								<tr>
<%--######################--%>
								<td>Password</td>
								<td>
<%
								try
								{
									if (!valeur_choix.equals(""))
									{
%>
										<input type="password" id="password_value"  name="new_password_name" onFocus="(this.value='')">
										<input type="hidden"  value="<%=password%>" name="password_name" >
<%
									}
									else
									{
%>
										<input type="password" id="password_value"  value="<%= password%>" name="password_name" onFocus="(this.value='')">
<%
									}
								}
								catch(Exception e)
								{
									System.out.print(e.getMessage());
								}
%>
								</td>
								<td style="width: 140px;">
								</td>
								</tr>
								</tbody>
								</table>
								</td>
								<td class="default_right"></td>
								</tr>
								<tr>
								<td class="default_bottom_left"></td>
								<td class="default_bottom"></td>
								<td class="default_bottom_right"></td>
								</tr>
								</tbody>
								</table>
								</td>
								<td style="width: 10px;">
								</td>
								<td></td>
								</tr>
								</tbody>
								</table>
								<input type="hidden" name=url id="url" value="">
								</form>
								</td>
								</tr>
							 </table>

							 <table>
							 <tr>
							 	<td>
									<center> <input type="button" name="xml" value="Continue" onclick="verif();" ></center>
								</td>
								<td>
									<center> <input type="button" value="Cancel" onclick="window.location.href = 'choix_criteres.jsp';" ></center>
								</td>

<%
								if (valeur_choix.equals("c"))
								{
%>
											<td>
												<center> <input type="button" value="Submit then delete another search form" onclick="modifUrl(); verif();"></center>
											</td>
<%								} %>
							</tr>
							</table>

							</center>

</body>
</html>