<%@ page language="java" import="fr.cirad.tropgene.*" contentType="text/html; charset=ISO-8859-1" pageEncoding="ISO-8859-1"%>

<%
	String sWebAppHome = "../";
	String sModule = request.getParameter("module");
%>

<style type="text/css">
/**
 * Menu principal
 */

#menu-principal{
	background: url(../images/menu_right.gif) right bottom no-repeat #06292b;
}

#menu-principal div{
	background: url(../images/menu_left.gif) left top  no-repeat transparent;
    zoom:1;
}

#menu-principal div div{
	background: none;
}

#menu-principal ul{
	margin-left:40px;
	display: block;
	padding-bottom: 46px;
}

#menu-principal ul li {
	float: left;
	color: #07292a;
	list-style: none;
	display: block;
	height: auto;
	margin-left: 0px;
	background: url(../images/sprites.png) 0 -1px no-repeat transparent;
	font-family: Verdana;
	text-align:left;
	text-transform:capitalize;
}


#menu-principal ul li.menuColor1, #menu-principal ul li.menuColor1 li{
	background-color: #e3264e;
}
#menu-principal ul li.menuColor2, #menu-principal ul li.menuColor2 li{
	background-color: #7da90a;
}
#menu-principal ul li.menuColor3, #menu-principal ul li.menuColor3 li{
	background-color: #00956b;
}
#menu-principal ul li.menuColor4, #menu-principal ul li.menuColor4 li{
	background-color: #007bbe;
}
#menu-principal ul li.menuColor5, #menu-principal ul li.menuColor5 li{
	background-color: #f2961b;
}
#menu-principal ul li.menuColor6, #menu-principal ul li.menuColor6 li{
	background-color: #7d0aa9;
}

/** Menu highilight */
#menu-principal ul li.strong{
	display: block;
	background-image: url(../images/sprites.png);
	background-position: -274px 0;
}

#menu-principal ul li ul li.strong{
	background-image: none;	color: #07292a;
}

#menu-principal ul li a {
	color: white;
	display: block;
	font-weight: bold;
	text-decoration: none;
	font-size: 13px;
	width: 100px;
	height: 41px;
	padding: 5px 0 0 8px;
	margin: 0 8px 0 20px;
}

/* Force le retour  la ligne */
#menu-principal ul li a span.first-word{
	display: block;
}

#menu-principal ul li ul {
	display: none;
	float: none;
	position: absolute;
    z-index: 200;
	border: 1px solid white;
	border-width: 1px 1px 0 1px;
	padding:0;
	margin-left: 10px;
	background: #06292b;
	width: auto;
}

#menu-principal ul li ul li{
	float: none;
	margin:0;
	padding:0;
	width: auto;	color: #07292a;
	border-bottom: 1px solid white;
	background-image: none;
}

#menu-principal ul li ul li a{
	height: auto;
	font-size: 10px;
	width: auto;
	margin:0;
	padding:5px;
	line-height: 100%;
	background-color: #06292b;
}

#menu-principal ul li ul li a:hover{
	background-color: transparent;
}

/**
 * Fin menu principal
 */
</style>

<script language="javascript" src="../JS/ibox.js"></script>
<script type="text/javascript" src="<%= sWebAppHome %>JS/mootools-core.js"></script>
<script type="text/javascript" src="<%= sWebAppHome %>JS/mootools-more.js"></script>
<script type="text/javascript" src="<%= sWebAppHome %>JS/mooquee.js"></script>
<script type="text/javascript" src="<%= sWebAppHome %>JS/tropgene_interface.js"></script>
<script language="javascript">
	/**
	 * Ajoute un evenement hover sur les LI du menu horizontal, (JS obligatoire pour IE6)
	 */
	function init_mainMenu()
	{
		var lis = $$('#menu-principal > div > ul > div > table > tbody > tr > td > li');

		lis.addEvent('mouseover', function(){
				if(ul = this.getElement('ul'))
				{
					ul.setStyle('display', 'block');
				}
		});

		lis.addEvent('mouseout', function(){
				if(ul = this.getElement('ul'))
				{
					ul.setStyle('display', 'none');
				}
		});
	}
</script>

<%
	String sRightSideText = "";
	try
	{	// first see if a contact form exists
		String sEmailContact = TextConstants.get("contactFormURL");
		sRightSideText = "<a style='color:#F2961B;' href='iFrameInIbox.jsp?url=" + java.net.URLEncoder.encode(sEmailContact) + "' rel='ibox&height=350'>Contact<br>TropgeneDB team</a>";
	}
	catch (Exception e)
	{
		try
		{	// then see if an email addres is provided
			String sEmailContact = TextConstants.get("contactEmail");
			sRightSideText = "Contact :<br><a style='color:#F2961B;' href='mailto:" + sEmailContact + "'>" + sEmailContact + "</a>";
		}
		catch (Exception ignored)
		{}
	}
	
	String sCopyrightText = "&copy; CIRAD";
	try
	{
		sCopyrightText = TextConstants.get("copyrightText");
	}
	catch (Exception ignored)
	{}

	if (new java.io.File(session.getServletContext().getRealPath("/") + "HTML" + java.io.File.separator + "copyright.html").exists())
		sCopyrightText = "<a style='color:#F2961B;' href='../HTML/copyright.html' rel='ibox&height=350'>" + sCopyrightText + "</a>";
	if (sModule != null)
	{
		try
		{
			sCopyrightText = "Last update : " + TextConstants.get(sModule + "_lastUpdate");
		}
		catch (Exception ignored)
		{}

		if (new java.io.File(session.getServletContext().getRealPath("/") + "HTML" + java.io.File.separator + sModule + "_data_origin.html").exists())
			sRightSideText = "<div style='margin-top:8px;'><a style='color:#F2961B; font-size:13px; font-weight:bold;' href='../HTML/" + sModule + "_data_origin.html' rel='ibox&height=480&width=640'>Data origin</a></div>";
	}
%>

<div style='position:absolute; min-width:1000px; width:100%; visibility:hidden;'>
<div style='color:#ffffff; float:left; margin-top:28px; margin-left:12px; visibility:visible;'>
<%= sCopyrightText %>
</div>
<div style='color:#ffffff; float:right; margin-top:20px; margin-right:12px; text-align:right; visibility:visible;'>
<div align='center'>
<%= sRightSideText %>
</div>
</div>
</div>

<div id="menu-principal">
<div align='center'>
<ul style='height:0px;'>
<div style='width:920px;' align='center'>

<table cellpadding='0' cellspacing='0' border='0' style='margin-right:100px;'>
<tr>

<%
	String[] moduleNames = ModuleListManager.getAvailableModules();

	String sPageName = request.getServletPath().replaceAll(".jsp", "");
	sPageName = sPageName.substring(sPageName.lastIndexOf("/") + 1);

	String[] menuLinks = TextConstants.get("menuLinks").split(";");
	for (int i=0; i<menuLinks.length; i++)
		if (new java.io.File(session.getServletContext().getRealPath("/") + "JSP" + java.io.File.separator + menuLinks[i] + ".jsp").exists())
		{
			String sMenuItemText;
			try
			{
				sMenuItemText = TextConstants.get("menuItem_" + i);
			}
			catch (java.util.MissingResourceException mre)
			{
				sMenuItemText = menuLinks[i];
			}
%>

		<td align='center'><li class="menuColor<%= (i%6) + 1 %><%= sPageName.equals(menuLinks[i]) ? " strong" : "" %>">

<%
			if ("interface".equals(menuLinks[i]))
			{
%>

		<a href="<%= moduleNames.length == 1 ? menuLinks[i] + ".jsp?module=" + moduleNames[0] : "javascript:;" %>"><%= sMenuItemText %></a>
			<ul style="display: none;">

<%
				if (moduleNames.length > 1)
					for (String sModuleName : moduleNames)
					{
%>

				<li>
					<a href="../?module=<%= sModuleName %>"><%= sModuleName %></a>
			 	</li>

<%					} %>

	</ul>

<%
			}
			else
			{
%>

			<a href="<%= menuLinks[i] %>.jsp"><%= sMenuItemText %></a>

<%			} %>

		</li></td>

<%		} %>

</tr>
</table>

</div>
</ul>
</div>
</div>

<script language='javascript'>init_mainMenu();</script>