<%@ page language="java" contentType="text/html; charset=ISO-8859-1" pageEncoding="ISO-8859-1"%>
<%@ page import="fr.cirad.tropgene.*" %>
<%@ page import="javax.xml.parsers.*" %>
<%@ page import="org.w3c.dom.*" %>	
<%@ page import="java.io.*" %>    
<%@ page import="java.util.regex.*" %>
<html>
<head>
</head>
<body>
<%
	//#######################################################################################################################
//############################################# DECLARATION DES VARIABLES ###############################################

String onglet= null;
String url=null;
String redirectURL =null;

String sModulePath = ModuleListManager.getModuleConfigPath(request.getParameter("module"))+ File.separator;
String fichier = sModulePath + "criteres.xml";

try
{
//######################################################################################################################
//############################################ RECUPERATION DES PARAMETRES #############################################

	onglet= request.getParameter("onglet");
	url = request.getParameter("url");
	
//######################################################################################################################
//########################################### PARSE DU FICHIER CRITERES.XML ############################################

	DocumentBuilderFactory fabrique = DocumentBuilderFactory.newInstance();
	DocumentBuilder constructeur = fabrique.newDocumentBuilder();
	File xml = new File(fichier);
	Document document = constructeur.parse(xml);
		    
	// PROPRIETES DU DOM
	document.setXmlVersion("1.0");
	document.setXmlStandalone(true);
		    
	//CREATION DE L ARBORESCENCE DU DOM
	Element racine = document.getDocumentElement();
	Node balise_racine=(Node)document.getDocumentElement();
	//balise onglet
	NodeList balise_onglet =racine.getElementsByTagName("onglet");	    
	    for(int i=0; i<balise_onglet.getLength(); i++)//pour chaque balise onglet
		{	    
	    	 Node element=balise_onglet.item(i);
		     Element e = (Element)balise_onglet.item(i);		
		     if (e.hasAttribute("nom"))
		     {		
		    	String attribute = e.getAttribute("nom");	
		    	
		    	Pattern p = Pattern.compile(attribute);
	        	Matcher m =p.matcher(onglet);	        	 
	        	 while(m.find())
		    	//################################################ONGLET CHOISI################################################
		//if (onglet.compareToIgnoreCase(attribute) == 0 )//si l'onglet correspond a celui selectionne dans le formulaire
		{
			balise_racine.removeChild(element);	//SUPPRESSION DE LONGLET 				
		}
		     }
		}
	    //transformation en fichier xml
	    Util.transformerXml(document,fichier, true);	
}
catch(Exception e)
{
   System.out.print(e.getMessage()); 
}

if(url=="")
{	
	 redirectURL = "choix_criteres.jsp";  	 
}
else
{
	redirectURL = url;
}
response.sendRedirect(redirectURL);
%>
</body>
</html>